/***********************************************
radhitdlutl
Purpose

Define constant values for error reporting codes.

Overview
Split four-byte integer into two. The two most significant (lefthand)
bytes encode the name of the function in which the error occurred.
The two least significant (righthand) bytes encode what the error was.

Definitions of Variables

Unique number for each code.




***********************************************/
#define	LEFT_MASK		0xffff0000
#define	RIGHT_MASK		0x0000ffff

#define	MKBASIS			0x00040000
#define	TRANSPMULT		0x00050000
#define	DETCOMP			0x00060000
#define	PSEUDOCOMP		0x00070000
#define	VEC_MULT		0x00090000
#define	INNER_PROD		0x000a0000
#define	SSORTP			0x000e0000
#define	READ_DATA		0x00140000
#define	MAT_INVERT		0x00170000


#define	NOT_A_NUMBER		0x00000003
#define	MEM_INSUFF		0x00000004
#define	MAT_SINGULAR		0x00000005
#define	POS_EXPECTED		0x00000006
#define	DIVIDE_ZERO		0x00000007
#define	NNEG_EXPECTED		0x00000008
#define	LOG_NEG			0x00000009
#define	ROOT_NEG		0x00000010
#define	FOPEN_FAILED		0x00000011
#define	COULDNOTREAD		0x00000012
#define	RESERVEDD11		0x00000013
#define	RESERVEDD12		0x00000014
#define	RESERVEDD13		0x00000015

#define	MALLOC_FAILED		0x00000071



#define FNANMASK   0x7F80 /* mask bits 1 - 8; all set on NaNs */
#define DNANMASK   0x7FF0 /* mask bits 1 - 11; all set on NaNs */
#define fnan(L) ((L & FNANMASK)==FNANMASK ? 1 : (L & FNANMASK) == 0 ? 2 : 0)
#define dnan(L) ((L & DNANMASK)==DNANMASK ? 1 : (L & DNANMASK) == 0 ? 2 : 0)
