/*********************************************** 
dlutl_matmult.c

Purpose

Multiply two matrices.

Overview
Loop over rows and columns of left-hand matrix.

Definitions of Variables

Input:
DP_MatLeft = Input Left-hand Matrix.
I_Num_RowsLeft = Number of Rows in Left-hand Matrix.
I_Num_ColumnsLeft = Number of Columns in Left-hand Matrix.
DP_MatRight = Input Right-hand Matrix.
I_Num_RowsRight = Number of Rows in Left-hand Matrix.
I_Num_ColumnsRight = Number of Columns in Right-hand Matrix.


Output:
DP_MatOut - Output Matirx.

Internal:
I_matsize = Total number of elements in output matrix.

***********************************************/

#include <stdio.h>
#include <string.h>
#include "dlutl.h"


dlutl_matmult(		double	*DP_MatLeft,
			int	I_Num_RowsLeft,
			int	I_Num_ColumnsLeft,
			double	*DP_MatRight,
			int	I_Num_RowsRight,
			int	I_Num_ColumnsRight,
			double	*DP_MatOut,
			int	*IP_Status)
{
int	k, l, m, I_matsize;

if(*IP_Status) return;

I_matsize = I_Num_RowsLeft*I_Num_ColumnsRight*sizeof(double);
memset((void *) DP_MatOut, 0, I_matsize);

for(k=0;k<I_Num_RowsLeft;k++)
for(l=0;l<I_Num_ColumnsRight;l++)	
for(m=0;m<I_Num_ColumnsLeft;m++)
DP_MatOut[k*I_Num_ColumnsRight+l] +=
DP_MatLeft[k*I_Num_ColumnsLeft+m]*DP_MatRight[m*I_Num_ColumnsRight+l];

}





