/*********************************************** 
dlutl_mkbasis.c

Purpose

Create a matrix whose columns are the basis vectors.

Overview
The general form of the regression basis vectors are encoded here.
For a linear regression to a quadratic polynomial, the three basis
vectors are a column of ones, a column consisting of 1, 2, 3, ...,
and a column consisting of 1, 4, 9, ...

Definitions of Variables

Input:
I_Num_Frames  = Seclected Number of Frames.
I_Num_Columns = Number of Columns in Basis Vector Matrix.

Output:
DP_GMatrix  =  Matrix of Basis Vectors.

Internal:


***********************************************/

#include <stdio.h>
#include <string.h>
#include "dlutl.h"



dlutl_mkbasis(		int	I_Num_Frames,
			int	I_Num_Columns,
			double	*DP_GMatrix,
			int	*IP_Status)
{
int	k, l, I_value;

if(*IP_Status) return;


for(k=0;k<I_Num_Frames;k++)	{

I_value = 1;
DP_GMatrix[I_Num_Columns*k + 0] = 1;
for(l=1;l<I_Num_Columns;l++)	{
I_value *= k+1;
DP_GMatrix[I_Num_Columns*k + l] = I_value;
}

}


}






