/*********************************************** 
dlutl_transpmult.c

Purpose

Compute the product of the transpose of the basis
vector matrix and itself.

Overview
Use loops. The shape of the matrix is given in the input variables.
Columns are the fast-changing index.

Definitions of Variables

Input:
I_Num_Rows  = Number of Rows in Matrix.
I_Num_Columns = Number of Columns in Matrix.
DP_Matrix  =  Input Matrix.

Output:
DP_TransProd = Product of transpose of DP_Matrix and itself.

Internal:
I_matsize = Total number of elements in output matrix.

***********************************************/

#include <stdio.h>
#include <string.h>
#include "dlutl.h"


dlutl_transpmult(	int	I_Num_Rows,
			int	I_Num_Columns,
			double	*DP_Matrix,
			double	*DP_TransProd,
			int	*IP_Status)
{
int	k, l, m, I_matsize;

if(*IP_Status) return;

I_matsize = I_Num_Columns*I_Num_Columns*sizeof(double);
memset((void *) DP_TransProd, 0, I_matsize);

for(k=0;k<I_Num_Columns;k++)
for(l=0;l<I_Num_Columns;l++)	
for(m=0;m<I_Num_Rows;m++)
DP_TransProd[k*I_Num_Columns+l] +=
DP_Matrix[m*I_Num_Columns+k]*DP_Matrix[m*I_Num_Columns+l];

	
}





