/* hdr.c  */
/* %W% %E% %U% */
/* #Copyright (C) 1992, California Institute of Technology. */
/* #U.S. Government Sponsorship under NASA Contract NAS7-918 */
/* #is acknowledged. */

#include "im.h"

#define MAXINS 50
char *im_history_line = (char *)0; /* user accessible history line */ 
                                          /* maximum 70 chars length      */

im_hdr(new_fid,old_fids,options)
int new_fid;
int old_fids[];
char options[]; /* "c" if want check all images are same 
                   "h" if only want history coppied
                 */
{
   int *fidptr;
   int n_fids;
   char card[82];
   char tmp[84];
   char *c;
   int stat;
   int i, n;
   int ifid; /* index into old_fids */
   int first_history;
   int n_par_lines;
   float tmp_real;
   char *im_key();

#define SIZEHISTARR 30
#define SIZEHISTLINE 72
   char histarr[SIZEHISTARR][SIZEHISTLINE];

   if (options == 0) options = "";

   if (options[0] =='c') return(-2);
    /************************************************
     im_hdr: multi-image consistency check not implemented yet
     first, if CRPIX's differ and CTYPE is linear, try to adjust CRPIX,CRVAL
      ERR:
          BUNIT differing
          effective NAXISn differing
          geom differing CTYPE or >= 1 pixel
      WARN:
          geom differing < 1 pixel
      ****************************************************/


   /* set in file_type */
   if ( ((struct fid_struct *) new_fid)->file_type == Type_unknown) {
      if (old_fids[0])
       ((struct fid_struct *) new_fid)->file_type =
       ((struct fid_struct *) old_fids[0])->file_type;
   }
   
   /* get boundary info from all files */
   i = 0;
   for (fidptr=old_fids; *fidptr; fidptr++) {
      if (i > MAXINS) return(-1);
      i++;
   }
   n_fids = i;

   /* copy "real" (non-history) header cards from first file */
   if (options[0] != 'h' && old_fids[0]) {
      stat = im_rkey_t(old_fids[0],card,"1");
      if (stat <0) return(stat);
      while (stat>=0) {

	 /* START RBH DELETE 
         if ( ((struct fid_struct *) new_fid)->file_type == Type_iraf
           && strncmp(card,"BLANK   ",8) == 0);
         else 
	 END RBH DELETE */
	 if (strncmp(card,"HISTORY ",8) != 0) {
             im_wkey_t(new_fid,card,"end");
         }
         stat = im_rkey_t(old_fids[0],card,"+");
      }
   }
   /* START RBH DELETE
   if ( ((struct fid_struct *) new_fid)->file_type == Type_iraf) {
      im_wkey_t(new_fid, "BLANK   = 0" ,"end");
   }
     END RBH DELETE */

   /* copy history from all files */
   for (fidptr=old_fids; *fidptr; fidptr++) {
      if (*fidptr < 0) break;
      first_history = 1;
      stat = im_rkey_t(*fidptr,card,"1");
      if (stat <0) return(-2); /* probably illegal fid */
      while (stat>=0) {
         if (card[0] == 'H') if (strncmp(card+1,"ISTORY ",7) == 0) {
            if (first_history) { /* See if IPAC HISTORY cards */
               if (card[8] != '*') {
                  im_wkey_t(new_fid,"HISTORY *0 (imported)","end");
               }
               first_history = 0;
            } /* end if first_history */
            im_wkey_t(new_fid,card,"end");
         } /* end if HISTORY */
      stat = im_rkey_t(*fidptr,card,"+");
      } /* end while stat>=0 */
      if (first_history) { /* See if no HISTORY cards */
         im_wkey_t(new_fid,"HISTORY *0 (imported)","end");
      }
   } /* end for(ifid=) */

/* store history info for THIS process */

   if(im_history_line != (char *)0 )
     if(*im_history_line != '\0'){
       im_history_line[71] = '\0';
       sprintf(card,"HISTORY *%d %s",n_fids,im_history_line);
       im_wkey_t(new_fid,card,"end");
     }

   return(0);
}
