#ifdef __INTEL_COMPILER
#include <time.h>
#endif
#ifdef __GNUC__
#include <time.h>
#endif
#include <sys/time.h>
/* %W% %E% %U% */
/* #Copyright (C) 1992, California Institute of Technology. */
/* #U.S. Government Sponsorship under NASA Contract NAS7-918 */
/* #is acknowledged. */

#define	SECONDS_1970_TO_1980	315532800

/* get_iraf_time -- get local time, seconds, epoch 1980.  */

get_iraf_time()
{
   struct timeval tp;
   struct timezone tzp;
   struct tm *localtime();
   long time_var;
   int dst;
	
   /* get GMT etc. in tp and tzp */
   gettimeofday(&tp,&tzp);
	
   /* Subtract minutes westward from GMT */
   time_var = tp.tv_sec - tzp.tz_minuteswest * 60;

   /* Correct for daylight savings time, if in effect */
   dst = localtime(&tp.tv_sec)->tm_isdst;
   if (dst) time_var += 3600;

   return (time_var - SECONDS_1970_TO_1980);
}
