/*   map_struct.h   */
/* Copyright (C) 1992, California Institute of Technology. */
/* U.S. Government Sponsorship under NASA Contract NAS7-918 */
/* is acknowledged. */

/* map projection data structure  */

#define PI 3.1415926535898
#define RAD_PER_DEG (PI/180.0)
#define DEG_PER_RAD (180.0/PI)
#define TWO_PI (PI * 2.0)

#define MAGIC_NUMBER 172737

struct map_struct {
  /* set by mapf or mapi */
  /*** these first 6 doubles not to change (used by custom functions) */
   double dlon; /* lon - lon0 */
   double lat; /* radians */
   double x, y;
  /* set by map_set */
   double sin_lat0;
   double cos_lat0;
   int magic;
   enum {P_AIT,P_TAN,P_SIN,P_ARC,P_POL,P_custom,P_linear} proj_type;
   char map_coord_type; /* r e g */
   double lon0; /* radians */
   double lat0; /* radians */
   double x_scale; /* pix per radian */
   double y_scale; /* pix per radian */
   double x0; /* offset to center */
   double y0; /* offset to center */
   double twist_angle1; /* radians */
   double twist_angle2; /* radians */
   int (* custom_mapf)();
   int (* custom_mapi)();
};
