/****************************************************************************
** Routine Name:                isis_valmallc.c                            **
**                                                                         **
** Description:                 This routine allocates memory space for    **
**                              variable value.                            **
**                                                                         **
** Input Parameters:            ifile   ____ file number                   **
**                                                                         **
** Output Parameters:            None			                   **
**									   **
** Function Return Values:      TBL_OK     ( 0), success                   **
**                              TBL_NOMEM  (-2), No enough memory          **
**                                                                         **
** Routine Be Called:		None					   **
**									   **
** Revision History:                                                       **
**                                                                         **
**   19??-??    John Good       Initial written                            **
**   1998-03    Angela Zhang    Seperate from original prototype	   **
**			        tbl_open.c.			           **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1997, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* Define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/*************************
* define global variable *
**************************/
char	*tbl_ival;			/* column content for ISIS file */
int	vlen;				/* length of val field */

isis_valmallc(ifile)
int 	ifile;	 			/* input file number */

/**************************
* Declear local variables *
***************************/
{
   int	value_len;			/* total length for value */
   int  i;				/* index */


/****************************
* Alllocate Memory for Value *
*****************************/

   if (tbl_ival == (char *) NULL)		
   {
       vlen =  TBL_MAXSTR; 
       tbl_ival  =  (char *) malloc(vlen * sizeof(char));
       if (tbl_ival == (char *) NULL)		
       {
           sprintf(tblerror, "Cannot malloc() enough memory. ");
           return(TBL_NOMEM);
       }
       for (i=0; i<vlen; ++i) tbl_ival[i] = '\0';
   }

   if (tbl[ifile]->reclen > vlen)
   {
       vlen =  vlen + TBL_MAXSTR; 
       tbl_ival  =  (char *) realloc(tbl_ival, vlen * sizeof(char));
       if (tbl_ival == (char *) NULL)		
       {
           sprintf(tblerror, "Cannot malloc() enough memory. ");
           return(TBL_NOMEM);
       }
       for (i=0; i<vlen; ++i) tbl_ival[i] = '\0';
    }

   return(TBL_OK);
}
