/* IMPORTANT CAAVEAT:

   Due to problems with the GNU link order, this source file appears in three libraries:
      cfitsio and tblio and dlcs
*/





/* mask for exponent in an IEEE float */
static union {unsigned long i; float f;  } static_exp_float =  {0x7f800000};
/* nan IEEE float */
static union {unsigned long i; float f;  } static_nan_float =  {0x7fc00000};
/* IEEE float mantissa */
static union {unsigned long i; float f;  } static_mant_float = {0x007fffff};
/* mask for exponent in an IEEE double */
static union {unsigned long long i; double f;  } static_exp_double =  {0x7ff0000000000000LL};
/* nan IEEE double */
static union {unsigned long long i; double f;  } static_nan_double =  {0x7ff8000000000000LL};
/* IEEE double infinity */
static union {unsigned long long i; double f;  } static_mant_double = {0x000fffffffffffffLL};

int iznanf(float f) {
  union {unsigned long i; float f;  } u;
  unsigned long exp,mant;
  u.f=f;
  exp=u.i&static_exp_float.i;
  mant=u.i&static_mant_float.i;
  return (exp==static_exp_float.i) && (mant!=0);
}
/* iznan functions iznanf and iznand
   test for exponent to be the maximum value and nonzero mantissa - does not count infinity as nan 
*/
int iznand(double f) {
  union {unsigned long long i; double f;  } u;
  unsigned long long exp,mant;
  u.f=f;
  exp=u.i&static_exp_double.i;
  mant=u.i&static_mant_double.i;
  return (exp==static_exp_double.i) && (mant!=0);
}

/* izinf function izinff and izinfd
   test for exponent being max and zero mantissa; does not count nan as infinity
*/
int izinff(float f) {
  union {unsigned long i; float f;  } u;
  unsigned long exp,mant;
  u.f=f;
  exp=u.i&static_exp_float.i;
  mant=u.i&static_mant_float.i;
  return (exp==static_exp_float.i) && (mant==0) ;
}

int izinfd(double f) {
  union {unsigned long long i; double f;  } u;
  unsigned long long exp,mant;
  u.f=f;
  exp=u.i&static_exp_double.i;
  mant=u.i&static_mant_double.i;
  return (exp==static_exp_double.i) && (mant==0);
}
