/****************************************************************************
**                                                                         **
** Routine Name:                tbl_delcol.c                               **
**                                                                         **
**                                                                         **
** Description:                 This routine marks the column for deletion **
**                              in the output file.                        **
**                              column exists.				   **
**                                                                         **
**                                                                         **
** Input Parameters:            ofile   ____ output file number            **
**                              icol    ____ input col # to be deleted     **
**                                                                         **
**                                                                         **
** Output Parameters:           None                                       **
**                                                                         **
**                                                                         **
** Function Return Values:                                                 **
**                              stat = TBL_OK       (  0)  success         **
**                              stat = TBL_ERROR    ( -1)  error           **
**                              stat = TBL_NOCOL    ( -7)  no such col.    **
**                                                                         **
**                                                                         **
** Usage:			tbl_delcol(int ofile, int col)             **
**                                                                         **
**                                                                         **
**									   **
**									   **
** Revision History:                                                       **
**                                                                         **
**   2004-08    Iffat Khan      first written                              **
**                                                                         **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/**************************
* Define Global Variables *
***************************/
int     tabletype;              /* FITS_ASCII */


tbl_delcol(ofile, icol)
int 	ofile;			/* output file number */	 
int     icol; 	/* indx of input file col to be deleted */


{
  /*************************
  * Define Local Variables *
  **************************/
  int	stat;
  int  ifile;

  /************************
  * Mark Column for       *
  * deletion.             *
  *************************/

    stat = 0;
    ifile = tbl_finfo[ofile]->link_handle;
    tbl[ifile]->colinfo[icol]->delcol = 1;
    return(stat);
}

