/****************************************************************************
**                                                                         **
** Routine Name:                tbl_fileinfo.c                             **
**                                                                         **
** Description:                 This routine retrieves a file information  **
**                                                                         **
** Input Parameters:            					   **
** 				ifile     ____ input file number           **
**                                                                         **
** Output Parameters:                                                      **
**                              *fileinfo  ____ file information           **
**                                                                         **
** Function Return Values:      stat = TBL_OK    ( 0), success             **
**                              stat = TBL_NOMEM (-2), not enough memory   **
**                              stat = TBL_NOTOPN(-6), file not open       **
**                                                                         **
** Routines Be Called:          FITS library calls			   **
**				     none             			   **
**									   **
**                              ISIS library calls:                        **
**				     none        		           **
**									   **
** Revision History:                                                       **
**									   **
**   1998-03    Angela Zhang    first written	                           **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/


/**************************
* define Includeing Files *
***************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>


tbl_fileinfo(ifile, fileinfo)
int 		    ifile;	/* input file number */	 
struct tbl_filinfo  **fileinfo;	/* struct for file information */	 
{

    /************************
    * allocate memory space *
    * for tbl_finfo         *
    *************************/
/*    if (fileinfo == (struct tbl_filinfo **) NULL)
    {
	fileinfo = (struct tbl_filinfo **)
	            malloc(sizeof(struct tbl_filinfo *));
	if (fileinfo == (struct tbl_filinfo **)NULL) 
		     return(TBL_NOMEM);
        
	*fileinfo= (struct tbl_filinfo *)
		    malloc(sizeof(struct tbl_filinfo));
	if (*fileinfo == (struct tbl_filinfo *)NULL) 
		     return(TBL_NOMEM);
    }
*/

    /**********************************
    * check if file has been open yet *
    ***********************************/
    if ( ifile < 0 || tbl_finfo[ifile]->fileptr == (FILE *) NULL)
	return (TBL_NOTOPN);
    else
    {
	*fileinfo = tbl_finfo[ifile];
	fileinfo  = &tbl_finfo[ifile];
    }
  return(TBL_OK);
}

