/****************************************************************************
**                                                                         **
** Routine Name:                tbl_ftype.c                                **
**                                                                         **
**                                                                         **
** Description:                 This routine returns FITS data type        **
**                                                                         **
**                                                                         **
** Input Parameters:            icol   ____  column number                 **
**				ifile  ----  file number                   **
**                                                                         **
**                                                                         **
** Output Parameters:           None                                       **
**                                                                         **
**                                                                         **
** Function Return Value:       stat = 1,              double              **
**                              stat = 2,              integer             **
**                              stat = 3,              character           **
**                              stat = TBL_NOTYP (-9), no such data type   **
**                                                                         **
**                                                                         **
** USAGE:			tbl_ftype(int icol)			   **
**                                                                         **
**                                                                         **
** Routines Be Called:   	FITS library calls			   **
**  				     None                                  **
**                                                                         **
** 				ISIS library calls			   **
**  				     None                                  **
**                                                                         **
** Revision History:                                                       **
**                                                                         **
**   1998-03    Angela Zhang    original written                           **
**                                                                         **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/**************************
* Define Global Variables *
***************************/
char    **tform[TBL_MAXFILES];      /* data format */
int     tabletype;              /* FITS_ASCII, FITS_BINARY, or ISIS_ASCII */


tbl_ftype(ifile, icol)
int 	ifile;			/* file number*/	 
int 	icol;			/* column number*/	 


{
    /*************************
    * Define Local Variables *
    **************************/
    int   	stat;                   /* status */
    int   	type;                   /* data type */
    int   	file_no;                /* index for a table file */
    int   	tfields;                /* number of column */


    file_no   = tbl_finfo[ifile]->file_handle;
    tabletype = tbl_finfo[ifile]->table_type;


    return(TBL_NOTYP);
}

