/****************************************************************************
**                                                                         **
** Routine Name:                tbl_keyinfo.c                              **
**                                                                         **
** Description:                 This routine retrieves keyword and value   **
**                              field associated with key index.           **
**                                                                         **
**                                                                         **
** Input Parameters/ output parameters:					   **
**                                                                         **
**				ifile   ____ input file number             **
**  			        ith	____ ith keyword		   **
**  			        numkey	____ number of keywords		   **
**  			        key	____ content of keywords	   **
**  			        keyval	____ value of keywords	           **
**                                                                         **
**                                                                         **
** Function Return Values:      stat = TBL_OK    ( 0), success             **
**                              stat = TBL_ERROR (-1), error               **
**                              stat = TBL_NOTOPN(-6), not open            **
**                                                                         **
** Usage:								   **
** 				tbl_keyinfo(int ifile, int* ith,           **
**					    int* numkey, char* key,	   **
**					    char* keyval, int itov)        **
**									   **
**									   **
** Routines Be Called:          FITS library calls:			   **
** 			 	     ffgkyn				   **
**                                                                         **
**				ISIS library calls:			   **
** 			 	     isis_keyinfo			   **
**                                                                         **
** Revision History:                                                       **
**                                                                         **
**   1998-03    Angela Zhang    initial written                            **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                     **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/


/**************************
* define Includeing Files *
***************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/*************************
* define global variable *
**************************/
int	tabletype;	/* FITS_ASCII, FITS_BINARY, ISIS_ASCII */

tbl_keyinfo(ifile, ith, key, kval)

int 	ifile;			/* input file number */	 
int 	ith;			/* ith keyword */	 
char 	*key;			/* keyword */	 
char 	*kval;			/* value field of a keyword */	 
{

    int		stat;		/* status of precedure */
    int		nkey;		/* number of keyword */
    int		tabletype;	/* index for table */
    int		file_no;	/* file index */
    int		i;		/* dummay variable */


    /*****************
    * get table type *
    ******************/
    tabletype = tbl_finfo[ifile]->table_type;
    file_no   = tbl_finfo[ifile]->file_handle;


    /**************************
    * get keyword information *
    ***************************/
    if (tabletype == ISIS_ASCII)
        stat =isis_keyinfo(file_no, ith, &nkey, key, kval);

     return(TBL_OK);
}

