/****************************************************************************
** Routine Name:                tbl_link.c                                 **
**                                                                         **
** Description:                 This routine links the input file with     **
**                              output file.                               **
**                                                                         **
** Input Parameters:            ifile   ____ input file number             **
**                              ofile   ____ output file number            **
**                                                                         **
** Output Parameters:           None                                       **
**                                                                         **
** Function Return Value:       stat                                       **
**                                                                         **
** Routines Be Called:   	None                                       **
**                                                                         **
** Revision History:                                                       **
**                                                                         **
**   2004-03    Iffat Khan      original written                           **
**                                                                         **
** Version:                     TBL0.0                                     **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                      **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/*************************
* Define Local Variables *
**************************/
int	tabletype;		/* indicate the table format */


tbl_link(ifile, ofile)

int 	ifile;			/* input file number */	 
int 	ofile;			/* output file number */	 


{
  /*************************
  * Define Local Variables *
  **************************/
  int   	stat;                   /* status */
  int           nrows;
  int           i;

/**********************
* Determine Data Type *
***********************/

    stat = 0;
    tbl_finfo[ifile]->link_handle = ofile;
    tbl_finfo[ofile]->link_handle = ifile;
    stat = tbl_numcheck(ifile, &nrows);
    if (stat == TBL_EOF) stat = 0;          
    tbl[ifile]->delrow = (int*) malloc(nrows * sizeof(int));
    if (tbl[ifile]->delrow == (int*) NULL)
    {
           sprintf(tblerror, "Cannot malloc() enough memory. ");
           return(TBL_NOMEM);
    }
    for (i=0; i<nrows; ++i)
      tbl[ifile]->delrow[i] = 0;
    return(stat);
}

