/****************************************************************************
** Routine Name:                TBL_type.c                                 **
**                                                                         **
** Description:                 This routine returns data type             **
**                                                                         **
** Input Parameters:            ifile   ____ input file number             **
**                              icol    ____ column number                 **
**                                                                         **
** Output Parameters:           None                                       **
**                                                                         **
** Function Return Value:       stat = 1,              double              **
**                              stat = 2,              integer             **
**                              stat = 3,              character           **
**                              stat = TBL_NOTYP (-9), no such data type   **
**                                                                         **
** Routines Be Called:   	None                                       **
**                                                                         **
** Revision History:                                                       **
**                                                                         **
**   1998-03    Angela Zhang    original written                           **
**                                                                         **
** Version:                     TBL0.0                                        **
**                                                                         **
**                                                                         **
** Infrared Science Information System                                      **
** California Institute of Technology                                      **
**                                                                         **
** Copyright (c) 1998, California Institute of Technology.                 **
** U. S. Government Sponsorship under NASA Contract                        **
** NAS7-???? is acknowledged.                                              **
**                                                                         **
*****************************************************************************/

/***********************
* define Include Files *
************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <tbl.h>

/*************************
* Define Local Variables *
**************************/
int	tabletype;		/* indicate the table format */


tbl_type(ifile, icol)

int 	ifile;			/* file number */	 
int 	icol;			/* column number*/	 


{
  /*************************
  * Define Local Variables *
  **************************/
  int   	stat;                   /* status */
  int   	type;                   /* data type */
  int   	file_no;                /* file index */

/**********************
* Determine Data Type *
***********************/

    file_no   = tbl_finfo[ifile]->file_handle;
    tabletype = tbl_finfo[ifile]->table_type;

    if (tabletype == ISIS_ASCII)
    {
	stat = isis_type(file_no, icol);
	return (stat);
    }
    return(TBL_NOTYP);
}

