#include <math.h>
#include "heapsort.h"

/* sorts a float array into ascending order 
   inputs -
      n number of items to sort
      y array of items to sort, zero origin index convention
*/
void heapsort( int n, float y[])
{
  int i,ir,j,l;
  float rra,*ra;

  ra=y-1;

  if (n < 2) return;
  l=(n >> 1)+1;
  ir=n;
  for (;;) {
    if (l > 1) {
      rra=ra[--l];
    } else {
      rra=ra[ir];
      ra[ir]=ra[1];
      if (--ir == 1) {
	ra[1]=rra;
	break;
      }
    }
    i=l;
    j=l+l;
    while (j <= ir) {
      if (j < ir && ra[j] < ra[j+1]) j++;
      if (rra < ra[j]) {
	ra[i]=ra[j];
	i=j;
	j <<= 1;
      } else j=ir+1;
    }
    ra[i]=rra;
  }
}

/* sorts a double array into ascending order 
   inputs -
      n number of items to sort
      y array of items to sort, zero origin index convention
*/
void heapsortd( int n, double y[])
{
  int i,ir,j,l;
  double rra,*ra;

  ra=y-1;

  if (n < 2) return;
  l=(n >> 1)+1;
  ir=n;
  for (;;) {
    if (l > 1) {
      rra=ra[--l];
    } else {
      rra=ra[ir];
      ra[ir]=ra[1];
      if (--ir == 1) {
	ra[1]=rra;
	break;
      }
    }
    i=l;
    j=l+l;
    while (j <= ir) {
      if (j < ir && ra[j] < ra[j+1]) j++;
      if (rra < ra[j]) {
	ra[i]=ra[j];
	i=j;
	j <<= 1;
      } else j=ir+1;
    }
    ra[i]=rra;
  }
}
