
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "uprop.h"
#include "nanvalue.h"

float nan_value;

int diagnose(float res, float left_arg, float right_arg, char* fname,int dzero);
int diagnose(float res, float left_arg, float right_arg, char* fname,int dzero){
  int result=0;
  if(isnan(left_arg) || isnan(right_arg) ) {
    if(!isnan(res)) {
      fprintf(stdout,"nantest failed nan expected, number %f = %f %s %f \n",res,left_arg,fname,right_arg);
      result++;
    }
  }
  else {
    if(isnan(res) && !dzero) {
      fprintf(stdout,"nantest failed,  number expected,  %f = %f %s %f \n",res,left_arg,fname,right_arg);
      result++;
    }
  }
  return (result);
}
int main(int argc, char *argv[]) {
  float first_arg[4]= {0, 0, 0.1, 100};
  float second_arg[4]={0, 0, 0.2, 200};
  float res, res_unc;
  int mask,dz,fi,si;
  float z=0;
  int iz=0,errcount=0;
  int n;

n=sizeof(first_arg)/sizeof(first_arg[0]);
 nan_value=NANVALUE;

  first_arg[0]=nan_value;
  second_arg[0]=nan_value;

  /* calling the library */
  for( fi=0;fi<n;fi++) {
    for( si=0;si<n;si++) {
      uprop_add(&res,&res_unc,&mask, first_arg[fi],z,iz,second_arg[si],z,iz);
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"uprop_add",0);
      uprop_sub(&res,&res_unc,&mask, first_arg[fi],z,iz,second_arg[si],z,iz);
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"uprop_sub",0);
      uprop_mul(&res,&res_unc,&mask, first_arg[fi],z,iz,second_arg[si],z,iz);
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"uprop_mul",0);
      uprop_div(&res,&res_unc,&mask, first_arg[fi],z,iz,second_arg[si],z,iz);
      dz=0;
      if((si==1) && (fi!=0))
        dz=1;
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"uprop_div",dz);
    }
  }
  /* doing the operation directly */
  for( fi=0;fi<n;fi++) {
    for( si=0;si<n;si++) {
      res=first_arg[fi]+second_arg[si];
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"native +",0);
      res=first_arg[fi]-second_arg[si];
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"native -",0);
      res=first_arg[fi]*second_arg[si];
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"native *",0);
      res=first_arg[fi]/second_arg[si];
      dz=0;
      if((si==1) && (fi!=0))
        dz=1;
      errcount+=diagnose(res,first_arg[fi],second_arg[si],"native /",dz);
    }
  }

  fprintf(stdout,"error count from nan propagate test=%d\n",errcount);
}
