#ifndef __spline
#define __spline

#include "splinefunc.h"

class spline {
 public:

  splinetab_type *sptab;

  spline(int n, double x[], double y[], double ysigma[]) {
    sptab=0;
    int k=splinetab(n,x,y,ysigma,&sptab);
    if((sptab==0)||(k<0)) {
      splinefree(sptab);
      sptab=0;
      return;
    }
  }
  spline(int n) {
   int k=splinetab_alloc(n,&sptab);
    if((sptab==0)||(k<0)) {
      splinefree(sptab);
      sptab=0;
      return;
    }
  }
  int calc() {
    int k=splinetab_calc(sptab);
    return k;
  }
  spline(int n, double x[], double y[], double ysigma[],double ypp[], double ypp_sigma[]) {
    sptab=0;
    int k=splinetab_alloc(n,&sptab);
    if((sptab==0)||(k<0)) {
      splinefree(sptab);
      sptab=0;
      return;
    }
    for(int i=0;i<n;i++) {
      sptab->xtab[i]=x[i];
      sptab->ytab[i]=y[i];
      sptab->ypp[i]=ypp[i];
      sptab->ypp_sigma[i]=ypp_sigma[i];
    }
  }
  spline(int n, double x[], double y[]) {
    sptab=0;
    int k=splinetab(n,x,y,0,&sptab);
    if((sptab==0)||(k<0)) {
      splinefree(sptab);
      sptab=0;
      return;
    }
  }
  int interp(double x, double xsigma, double &y, double& ysigma) {
    int k=splineinterp(x,xsigma,&y,&ysigma,sptab);
    return k;
  }
  ~spline() {
    splinefree(sptab);
    sptab=0;
  }
};
#endif

